/*
 * Copyright (C) 2012, H&D Wireless AB All rights reserved.
 *
 * The license to use this software in whole and in part and to
 * redistribute it in any form follows with the WiFi HW module from H&D
 * Wireless and is granted under the following restrictions:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. The name of H&D Wireless AB may not be used to endorse or promote
 *    products derived from this software without specific prior written
 *    permission.
 *
 * 4. The software may only be used together with hardware from H&D
 *    Wireless all other use is prohibited.
 *
 * 5. The license to use and redistribute the software is granted
 *    together with the purchase of a hardware platform on a one to one
 *    basis.
 *
 * 6. The binary code may not be reversed engineered or by other means
 *    copied to circumvent this license.
 * 
 * THIS SOFTWARE IS PROVIDED BY H&D WIRELESS AB ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE EXPRESSLY AND SPECIFICALLY DISCLAIMED. IN NO EVENT
 * SHALL HD WIRELESS AB BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * For more information regarding this software license Contact H&D
 * Wireless AB (support@hd-wireless.se).
 *
 */

#ifndef OWL_PORT_H
#define OWL_PORT_H

#define vsniprintf vsnprintf

extern void owl_putc(char c);

#define STM3210E_EVAL     1
#define SPB860            2
#define SPB820            3
#define STM324XG_EVAL     4
#define SPB813            5
#define STM32F4_DISCOVERY 6

#define STM32_FAMILY_F10X 1
#define STM32_FAMILY_L1XX 2
#define STM32_FAMILY_F4XX 3

#define STM32_CREATE_PIN(port, offset) (((uint32_t) (port) | (offset)))
#define STM32_PORT(pin) ((GPIO_TypeDef *) ((pin) & 0xffffff00))
#define STM32_PIN(pin)  ((uint32_t) (1 << ((pin) & 0xff)))
#define STM32_PINSOURCE(pin) ((uint32_t) (pin & 0x000000ff))
#define STM32_PORTSOURCE(pin) ((uint8_t) ((uint32_t) (pin & 0xffff0000) >> 10))

/* For GPIO map (see owl_gpio.c) */
struct gpiomap {
        const char *str;
        int val;
};

/* Include _after_ declaring struct gpiomap */
#include <board.h>

/* Defined by the bootloader only */
#ifndef BOOTLOADER
# define BOOTLOADER 0
#endif

/* STM32_CONFIG_BOOTLOADER is defined for application that uses the bootlader,
   and for the bootloader itself */
#ifndef STM32_CONFIG_BOOTLOADER
# define STM32_CONFIG_BOOTLOADER 0
#endif

/* STM32_CONFIG_BOOTLOADER_SIZE is defined for application that uses the
   bootlader, and for the bootloader itself */
#ifndef STM32_CONFIG_BOOTLOADER_SIZE
# define STM32_CONFIG_BOOTLOADER_SIZE 0
#endif

/* STM32_CONFIG_OTP_SIZE is defined for application that uses the
   otp area, and for the bootloader */
#ifndef STM32_CONFIG_OTP_SIZE
# define STM32_CONFIG_OTP_SIZE 0
#endif

/* STM32_CONFIG_MTD_SIZE is defined for boards that only uses a portion of the
   actual flash size (e.g. if there are different flashes mounted on different
   flavours of the same board */
#ifndef STM32_CONFIG_MTD_SIZE
# define STM32_CONFIG_MTD_SIZE 0
#endif

#define STM32_CONFIG_FIRMWARE_NAME "firmware"

#define ISR_FUNC

#endif
