# Copyright (C) 2012, H&D Wireless AB All rights reserved.
#
# The license to use this software in whole and in part and to
# redistribute it in any form follows with the WiFi HW module from H&D
# Wireless and is granted under the following restrictions:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# 3. The name of H&D Wireless AB may not be used to endorse or promote
#    products derived from this software without specific prior written
#    permission.
#
# 4. The software may only be used together with hardware from H&D
#    Wireless all other use is prohibited.
#
# 5. The license to use and redistribute the software is granted
#    together with the purchase of a hardware platform on a one to one
#    basis.
#
# 6. The binary code may not be reversed engineered or by other means
#    copied to circumvent this license.
#
# THIS SOFTWARE IS PROVIDED BY H&D WIRELESS AB ``AS IS'' AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE EXPRESSLY AND SPECIFICALLY DISCLAIMED. IN NO EVENT
# SHALL HD WIRELESS AB BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#
# For more information regarding this software license Contact H&D
# Wireless AB (support@hd-wireless.se).

BOARD_NETIF ?= wlif.c
LWIP_INCS  =
LWIP_SRCS  =
ifeq ($(LWIP_HD_MEMP),1)
	LWIP_INCS += $(TRUNK_PATH)/toolkit/lwip/lwip-1.4.1/src/include
	LWIP_SRCS += $(TRUNK_PATH)/toolkit/lwip/lwip-1.4.1/src/core/memp.c
else
	LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/core/memp.c
endif

LWIP_PATH ?= $(EXT_PATH)/toolkit/lwip
LWIP_SRCS += $(TRUNK_PATH)/toolkit/lwip/lwip-1.4.1/src/core/tcp.c
LWIP_SRCS += $(TRUNK_PATH)/toolkit/lwip/netif/$(BOARD_NETIF)

LWIP_INCS += $(TRUNK_PATH)/toolkit/lwip/include

LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/core/init.c
LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/core/def.c
LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/core/pbuf.c
LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/core/netif.c
LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/core/stats.c
LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/core/raw.c
LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/core/dhcp.c
LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/core/mem.c
LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/core/ipv4/ip_addr.c
LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/core/ipv4/ip_frag.c
LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/core/ipv4/ip.c
LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/core/ipv4/icmp.c
LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/core/ipv4/igmp.c
LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/core/ipv4/inet_chksum.c
LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/core/ipv4/inet.c
LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/core/udp.c
LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/core/tcp_in.c
LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/core/tcp_out.c
LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/core/dns.c
LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/core/timers.c
LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/core/ipv4/autoip.c
LWIP_SRCS += $(LWIP_PATH)/lwip-1.4.1/src/netif/etharp.c

LWIP_INCS += $(LWIP_PATH)/lwip-1.4.1/src/include
LWIP_INCS += $(LWIP_PATH)/lwip-1.4.1/src/include/ipv4

LWIP_CFLAGS += -Wno-strict-prototypes
