/*
 * Copyright (C) 2012, H&D Wireless AB All rights reserved.
 *
 * The license to use this software in whole and in part and to
 * redistribute it in any form follows with the WiFi HW module from H&D
 * Wireless and is granted under the following restrictions:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. The name of H&D Wireless AB may not be used to endorse or promote
 *    products derived from this software without specific prior written
 *    permission.
 *
 * 4. The software may only be used together with hardware from H&D
 *    Wireless all other use is prohibited.
 *
 * 5. The license to use and redistribute the software is granted
 *    together with the purchase of a hardware platform on a one to one
 *    basis.
 *
 * 6. The binary code may not be reversed engineered or by other means
 *    copied to circumvent this license.
 * 
 * THIS SOFTWARE IS PROVIDED BY H&D WIRELESS AB ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE EXPRESSLY AND SPECIFICALLY DISCLAIMED. IN NO EVENT
 * SHALL HD WIRELESS AB BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * For more information regarding this software license Contact H&D
 * Wireless AB (support@hd-wireless.se).
 *
 */

#include <owl/core/owl_err.h>
#include <owl/core/owl_debug.h>

#ifndef OWL_DEBUG_NO_TIME
uint32_t debug_time = 0;
#endif

void
owl_hexdump_f(const char *title, const void *pos, int len)
{
        const char *cpos = pos;
        char line[80], *p;
	int i, j;
        
        owl_os_printf("%s - hexdump(len=%d):\n\r", title, len);
        
        if (pos == NULL)
                return;

        for(i = 0; i < len; i += 16) {
		p = line;
                p += owl_os_snprintf(p, line + sizeof(line) - p, "%04x  ", i);
		for(j = 0; j < 16; j++) {
                        if(i + j < len)
                                owl_os_snprintf(p, line + sizeof(line) - p,
                                                "%02x ",
                                                (unsigned char)cpos[i + j]);
			else
                                owl_os_strcpy(p, "   ");
			p += 3;
		}

                owl_os_strcpy(p, ": ");
                for(j = 0; j < 16; j++) {
                    if(i + j < len) {
                        if(owl_isprint((unsigned char) cpos[i + j]))
                            *p++ = cpos[i + j];
                        else
                            *p++ = '.';
                    }
                }
		*p = '\0';
		owl_os_printf("   %s\n\r", line);
	}
} 

