/*
 * Copyright (C) 2012, H&D Wireless AB All rights reserved.
 *
 * The license to use this software in whole and in part and to
 * redistribute it in any form follows with the WiFi HW module from H&D
 * Wireless and is granted under the following restrictions:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. The name of H&D Wireless AB may not be used to endorse or promote
 *    products derived from this software without specific prior written
 *    permission.
 *
 * 4. The software may only be used together with hardware from H&D
 *    Wireless all other use is prohibited.
 *
 * 5. The license to use and redistribute the software is granted
 *    together with the purchase of a hardware platform on a one to one
 *    basis.
 *
 * 6. The binary code may not be reversed engineered or by other means
 *    copied to circumvent this license.
 *
 * THIS SOFTWARE IS PROVIDED BY H&D WIRELESS AB ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE EXPRESSLY AND SPECIFICALLY DISCLAIMED. IN NO EVENT
 * SHALL HD WIRELESS AB BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * For more information regarding this software license Contact H&D
 * Wireless AB (support@hd-wireless.se).
 *
 */

#ifndef OWL_ERR_H
#define OWL_ERR_H

#define OWL_FAILURE   -1  /* general failure */
#define OWL_ERR_PARAM -2  /* parameter error */
#define OWL_ERR_MEM   -3  /* out of memory */
#define OWL_ERR_CONN  -4  /* no connection */
#define OWL_ERR_STATE -5  /* invalid state */
#define OWL_ERR_PARSE -6  /* input parsing error */
#define OWL_ERR_PATH  -7  /* path not found */
#define OWL_ERR_TYPE  -8  /* incompatible type */
#define OWL_ERR_PERM  -9  /* no permission */
#define OWL_ERR_NOTSUPP -10 /* operation not supported */
#define OWL_ERR_RANGE -11 /* out of range */
#define OWL_ERR_SIZE  -12 /* bad size */
#define OWL_ERR_AGAIN -13 /* retry later */
#define OWL_ERR_BUSY  -14 /* busy */
#define OWL_ERR_DISABLED -15 /* function is disabled */
#define OWL_ERR_PROTO -16 /* protocol error */
#define OWL_ERR_TIMEOUT -17 /* timeout */
#define OWL_ERR_IGNORED -18 /* ignored, no effect */
#define OWL_ERR_CANCEL -19 /* canceled by remote */
#define OWL_ERR_SYNC   -20 /* sync error */
#define OWL_ERR_ABORT  -21  /* aborted */
#define OWL_ERR_INUSE -22 /* already in use */
#define OWL_ERR_USAGE -23 /* general usage error */
#define OWL_ERR_CHECKSUM -24 /* checksum failure */
#define OWL_ERR_DESTROYED -25 /* already destroyed */

const char *owl_error(int err);

#endif
